DECLARE SUB ShiftUp ()
DECLARE SUB ShiftDown ()
DECLARE SUB move1colour ()
DECLARE SUB GetFileLine (ch%, a$)
DECLARE SUB GetCoord ()
DECLARE SUB Options ()
DECLARE SUB Bold (a$)
DECLARE SUB DoSetup (a$)
DECLARE SUB DoMove (a$)
DECLARE SUB Import ()
DECLARE FUNCTION NormalCorners$ (aa$, xl%, xr%, yl%, yr%)
DECLARE FUNCTION Hc% (coord%)
DECLARE FUNCTION GetLine$ (term$)
DECLARE FUNCTION Disp$ (x%, y%)
DECLARE SUB ToHtml (Html%)
DECLARE SUB Missing ()
DECLARE SUB ShiftLeft ()
DECLARE SUB ShiftRight ()
DECLARE FUNCTION Eval! (s$)
DECLARE SUB Instructions ()
DECLARE SUB ToFile ()
DECLARE SUB Enter ()
DECLARE SUB ShowAll ()
DECLARE SUB Show (y!)

REM go enterer - in goscribe format

DEFINT A-Z
CONST Version$ = "Entergo v47 2004-07-23"
CONST maxmove = 400
CONST ext$ = ".gif" 'HTML file extension, may be null
DIM SHARED b%(19, 19) 'The board
DIM SHARED c% 'Column
DIM SHARED r% 'Row
DIM SHARED Highest% 'Stone so far
DIM SHARED rw%(maxmove) ' Holds the row for each played move
DIM SHARED er%
DIM SHARED move%(maxmove, 2)
DIM SHARED temp$
DIM SHARED showsetup%
DIM SHARED colour$
DIM SHARED bdsize%
DIM SHARED corner$(2)
DIM SHARED maxshow%
DIM SHARED preserve%
DIM SHARED offset%
DIM SHARED displayoffset%
DIM SHARED Pg$
DIM SHARED Type$
DIM SHARED DiaNum$
DIM SHARED Blanknum
DIM SHARED Reduce
DIM SHARED Ascii2
DIM SHARED bkl$
DIM SHARED wtl$
DIM SHARED bk$
DIM SHARED wt$

CONST empty = 0
CONST black = -1
CONST white = -2
CONST label = -1000 'add to ascii character / neg_number
    'empty <A>= -935, empty <1> = -1001
    'black #A#= -1935, black #1# = -2001
    'white oAo= -2935, white o1o = -3001
CONST blabel = -2000
CONST wlabel = -3000
CONST column$ = "abcdefghjklmnopqrst"
CONST kolumn$ = "ABCYZFGHJKLMNOPQRST"
CONST BufferChar$ = "0123456789&*(-"
CONST False = 0
CONST TRUE = NOT False
temp$ = ENVIRON$("TEMP")
bdsize% = 19
maxshow% = maxmove
preserve% = 0
offset% = 0
displayoffset% = 0
Pg$ = "00"
Type$ = "Diagram"
DiaNum$ = "1"
Blanknum = 0
Reduce = 0
Ascii2 = TRUE
bkl$ = CHR$(176)
wtl$ = CHR$(178)
bk$ = bkl$ + "b" + bkl$
wt$ = wtl$ + "w" + wtl$

FOR y = 1 TO bdsize%
    FOR x = 1 TO bdsize%
        b%(x, y) = empty
    NEXT x
NEXT y

Instructions
PRINT "Board size ("; bdsize%; ")";
INPUT a$
IF a$ <> "" THEN
    x = VAL(a$)
    IF x >= 3 AND x <= 19 THEN bdsize% = x
END IF
corner$(1) = MID$(column$, bdsize%, 1) + LTRIM$(STR$(bdsize%))
corner$(2) = "a1"

showsetup% = 0
ShowAll
c% = 1
r% = bdsize%

Enter
ToFile

SYSTEM

Handler:
    er% = ERR
RESUME NEXT

SUB Bold (a$)
    COLOR 0, 7
    PRINT a$;
    COLOR 7, 0
END SUB

FUNCTION Disp$ (x%, y%)
    mn = b%(x, y)
    IF mn > maxshow% THEN
        a$ = "  :"
    ELSEIF mn > showsetup% THEN
        a$ = RIGHT$("  " + STR$(mn - displayoffset%), 3)
    ELSEIF mn > 0 THEN
        a$ = MID$(colour$, ((mn + 1) MOD 2) * 3 + 1, 3)
    ELSEIF mn = empty THEN
        IF Hc(x) AND Hc(y) THEN
            a$ = "  " + CHR$(22)
        ELSE
            a$ = "  ."
        END IF
    ELSEIF mn = black THEN
        a$ = bk$
    ELSEIF mn = white THEN
        a$ = wt$
    ELSE
        lb$ = "<"
        rb$ = ">"
        l = label
        IF mn < (500 + wlabel) THEN
            lb$ = wtl$
            rb$ = wtl$
            l = wlabel
        ELSEIF mn < (500 + blabel) THEN
            lb$ = bkl$
            rb$ = bkl$
            l = blabel
        END IF
        ch = mn - l
        IF ch >= ASC("@") AND ch <= ASC("[") THEN
            a$ = lb$ + CHR$(ch) + rb$
        ELSEIF ch < 0 AND ch >= -99 THEN
            ch = -ch
            a$ = LEFT$(lb$ + LTRIM$(STR$(ch)) + rb$, 3)
        ELSE
            a$ = "???"
        END IF
    END IF
    Disp$ = a$
END FUNCTION

SUB DoMove (a$)
    b$ = LTRIM$(MID$(a$, 3))
    mn = VAL(LEFT$(b$, INSTR(b$, " ")))
    b$ = LTRIM$(RIGHT$(RTRIM$(a$), 3))
    g$ = NormalCorners$(b$ + b$, xl, xr, yl, yr)
    r% = yl
    c% = xl
    IF rw%(mn) > 0 THEN
        PRINT #4, "Move already on board: "; a$
        PRINT "Move already on board: "; a$
    ELSEIF b%(c%, r%) <> empty THEN
        PRINT #4, "Board location already full: "; a$
        PRINT "Board location already full: "; a$
    ELSE
        b%(c%, r%) = mn
        rw%(mn) = r%
        IF mn > Highest% THEN
            Highest% = mn
        END IF
    END IF
END SUB

SUB DoSetup (a$)
    b$ = LTRIM$(MID$(a$, 6))
    IF LEFT$(b$, 1) = "B" THEN
        stone = black
    ELSE
        stone = white
    END IF
    b$ = RTRIM$(LTRIM$(MID$(b$, 2)))
    DO UNTIL b$ = ""
        i = INSTR(b$ + " ", " ")
        c$ = LEFT$(b$, i - 1)
        b$ = LTRIM$(MID$(b$, i))
        g$ = NormalCorners$(c$ + c$, xl, xr, yl, yr)
        r% = yl
        c% = xl
        IF b%(c%, r%) <> empty THEN
            PRINT #4, "Board location already full for setup : "; c$
            PRINT "Board location already full for setup : "; c$
        ELSE
            b%(c%, r%) = stone
        END IF
    LOOP
END SUB

DEFSNG A-Z
SUB Enter
FOR i = 1 TO maxmove
    rw%(i) = 0 'No moves yet played
NEXT i
colour$ = bk$ + wt$
buzz = 0
oldbuzz = 0
Highest% = 0
z$ = CHR$(0)
dstp = 1 'Default step size
DO
    LOCATE 21 - r%, c% * 4 - 2
    Bold Disp$(c%, r%)
    IF buzz THEN
        FOR buzz = 0 TO 1000
            a = RND
        NEXT buzz
        SOUND 100, 5
        buzz = 0
    END IF
    a$ = GetLine$(term$)
    b$ = LCASE$(a$)
    k$ = LEFT$(b$, 1)
    stp = dstp 'Step to move cursor position by
    hash$ = ""
    mn = b%(c%, r%) 'Remember what move number (or other) is on board
                     'at current position
    omn = mn 'Copy - Old move number
    b%(c%, r%) = empty 'Now empty the position
    IF mn > 0 THEN
        rw%(mn) = 0 'And empty the move that played that position
    END IF
    IF term$ = z$ + CHR$(&H4B) THEN 'Left
        stp = -1
    ELSEIF term$ = z$ + CHR$(&H4D) THEN 'Right
        stp = 1
    ELSEIF term$ = z$ + CHR$(&H48) THEN 'Up
        stp = -bdsize%
    ELSEIF term$ = z$ + CHR$(&H50) THEN 'Down
        stp = bdsize%
    ELSEIF term$ = z$ + CHR$(&H4F) THEN 'End
        stp = bdsize% - c%
    ELSEIF term$ = z$ + CHR$(&H47) THEN 'Home
        stp = (1 - c%) - (bdsize% * (bdsize% - r%))
    END IF
    IF term$ = z$ + CHR$(&H53) THEN 'Delete
        stp = 0
        mn = empty
        omn = empty 'Overcome PRESERVE
    ELSEIF term$ = z$ + CHR$(&H52) THEN 'Insert
        stp = 0
        hash$ = "ins"
    ELSEIF term$ = z$ + CHR$(&HF) THEN  'Shift Tab
        stp = 0
        hash$ = "coord"
    ELSEIF term$ = z$ + CHR$(&H6B) THEN  'Alt F4
        stp = 0
        hash$ = "q"
    ELSEIF a$ = CHR$(&HD) THEN 'Return
        REM nop
    ELSEIF b$ = "#" THEN
        stp = 0
        hash$ = "#"
    ELSEIF b$ = ":" THEN
        stp = 0
        hash$ = ":"
    ELSEIF b$ = "~" THEN
        stp = 0
        corner$(1) = corner$(2)
        corner$(2) = MID$(column$, c%, 1) + LTRIM$(STR$(r%))
    ELSEIF b$ = "@" THEN
        stp = 0
        hash$ = "@"
    ELSEIF b$ = "!" THEN
        stp = 0
        hash$ = "!"
    ELSEIF b$ = "?" THEN
        stp = 0
        hash$ = "?"
    ELSEIF b$ = "+" THEN
        dstp = 1
        stp = 0
    ELSEIF b$ = "=" THEN
        dstp = 0
        stp = 0
    ELSEIF b$ = "q" THEN
        stp = 0
        hash$ = "q"
    ELSEIF b$ = "b" THEN
        mn = black
    ELSEIF b$ = "w" THEN
        mn = white
    ELSEIF b$ = " " THEN
        mn = empty
    ELSEIF (k$ = "*") OR (k$ = "&") OR (k$ = "(") THEN
        term$ = UCASE$(term$)
        m = Eval(MID$(b$, 2))
        IF k$ = "*" THEN mn = label
        IF k$ = "&" THEN mn = blabel
        IF k$ = "(" THEN mn = wlabel
        IF term$ >= "@" AND term$ <= "[" THEN
            mn = mn + ASC(term$) '@,[ and letters
        ELSEIF m > 0 AND m <= 99 THEN 'numbers
            'mn = mn - m (suppress coloured numbered stones)
            mn = label - m
        ELSE
            BEEP
            stp = 0
        END IF
    ELSEIF b$ = "v" THEN
        b%(c%, r%) = mn 'Put the current move back
        IF mn > 0 THEN 'If a real move
            rw%(mn) = r% 'Move number ## was played in row ...
        END IF
        ShiftDown
        mn = empty 'Board position will be empty
        stp = 0 'Leave cursor still
    ELSEIF b$ = "^" THEN
        b%(c%, r%) = mn 'Put the current move back
        IF mn > 0 THEN 'If a real move
            rw%(mn) = r% 'Move number ## was played in row ...
        END IF
        ShiftUp
        mn = b%(c%, r%) 'Remember what move number (or other) is on board
                         'at current position
        stp = 0 'Leave cursor still
    ELSEIF b$ = ">" THEN
        b%(c%, r%) = mn 'Put the current move back
        IF mn > 0 THEN 'If a real move
            rw%(mn) = r% 'Move number ## was played in row ...
        END IF
        ShiftRight
        mn = empty 'Board position will be empty
        stp = 0 'Leave cursor still
    ELSEIF b$ = "<" THEN
        'The current move will be zapped
        ShiftLeft
        mn = b%(c%, r%) 'Remember what move number (or other) is now
                        'at the current position
        stp = 0 'Leave cursor still
    ELSEIF term$ = a$ THEN 'A solitary cursor key
        'No action required - avoid the ELSE part of this IF.
    ELSE 'Its none of the special cases, so it ought to be a number
        m = Eval(b$)
        IF m > 0 THEN
            m = m + offset%
        ELSE
            m = -m
        END IF
        IF m > 0 AND m <= maxmove THEN 'Its a played move
            mn = m 'Declare position to be the played move
            IF rw%(m) > 0 THEN 'That move as already been played
                LOCATE 24, 20
                PRINT "    Move"; m; " already in row"; rw%(m);
                BEEP
                mn = empty 'So don't put anything in cursor posn.
                stp = 0 'And don't move cursor
            END IF
            IF mn > Highest% THEN Highest% = mn
        ELSE 'The number was invalid
            BEEP
            stp = 0 'Stay still, don't change anything.
        END IF
    END IF
    'Check ok to write to location
    IF (preserve% = 0) OR (omn = empty) OR (mn = omn) THEN
        'OK to write
    ELSE
        mn = omn
        LOCATE 24, 20
        PRINT "    Point preserved, already full.";
        stp = 0
        BEEP
    END IF
    b%(c%, r%) = mn 'Put position state in board array (empty, bk, wt, move#)
    IF mn > 0 THEN 'If a real move
        rw%(mn) = r% 'Move number ## was played in row ...
    END IF
    Show (r%)
    c% = c% + stp
    IF c% < 1 THEN
        DO WHILE c% < 1
            c% = c% + bdsize%
            r% = r% + 1' up is positive
        LOOP
        oldbuzz = 0
    ELSEIF c% > bdsize% THEN
        c% = c% - bdsize%
        r% = r% - 1' down is negative
        IF c% = 1 THEN
            IF oldbuzz = 0 THEN
                buzz = 1
                oldbuzz = 1
            END IF
        ELSE
            oldbuzz = 0
        END IF
    ELSE
        oldbuzz = 0
    END IF
    IF r% > bdsize% THEN r% = r% - bdsize%
    IF r% < 1 THEN r% = r% + bdsize%
    IF hash$ <> "" THEN
        IF hash$ = "#" THEN
            ToHtml TRUE
        ELSEIF hash$ = ":" THEN
            ToHtml False
        ELSEIF hash$ = "@" THEN
            ToFile
        ELSEIF hash$ = "ins" THEN
            Import
        ELSEIF hash$ = "coord" THEN
            GetCoord
        ELSEIF hash$ = "?" THEN
            Instructions
            a$ = INPUT$(1)
        ELSEIF hash$ = "!" THEN
            Options
        ELSEIF hash$ = "q" THEN
            CLS
            PRINT "Select <C> to restart with a clear board."
            PRINT
            PRINT "Are you sure you want to QUIT (Y/N/C)?"
            a$ = INPUT$(1)
            IF UCASE$(a$) = "Y" THEN
                ShowAll
                SYSTEM
            ELSEIF UCASE$(a$) = "C" THEN
                RUN
            END IF
        END IF
        ShowAll
    END IF
LOOP
END SUB

FUNCTION Eval (s$) 'Return 0 if invalid string
    DIM v
    ON ERROR GOTO Handler
    er% = 0
    c$ = UCASE$(LEFT$(s$, 1))
    IF c$ = "D" OR c$ = "E" THEN
        v = 0
    ELSE
        v = VAL(s$)
    END IF
    ON ERROR GOTO 0
    IF er% THEN v = 0
    Eval = v
END FUNCTION

DEFINT A-Z
SUB GetCoord
    CLS
    PRINT "This option permits the entering of data using the coordinate"
    PRINT "system (e.g. K10)."
    PRINT
    PRINT "At each prompt, enter a space separated string of parameters:"
    PRINT "Case is irrelevant."
    Bold "#B"
    PRINT " = Black setup stones."
    Bold "#W"
    PRINT " = White setup stones."
    Bold "number"
    PRINT " = Start of an alternating sequence at move 'number'."
    Bold "coordinate"
    PRINT " {letter/number} = position of item on the board."
    Bold "##"
    PRINT " = Quit coordinate entry and return to normal mode."
    PRINT
    PRINT "Entered parameters will be copied to " + temp$ + "\ENTERGO.TXT"
    CLOSE #4
    OPEN temp$ + "\ENTERGO.TXT" FOR APPEND AS #4
    PRINT #4, "Coordinate parameters "; f$
    mv = 1
    quit = False
    DO
        IF mv = black THEN
            PRINT #4, "Blk >";
            PRINT "Blk >";
        ELSEIF mv = white THEN
            PRINT #4, "Wht >";
            PRINT "Wht >";
        ELSE
            PRINT #4, mv; ">";
            PRINT mv; ">";
        END IF
        LINE INPUT a$
        PRINT #4, a$
        a$ = UCASE$(RTRIM$(LTRIM$(a$)))
        DO
            i = INSTR(a$ + " ", " ")
            b$ = LEFT$(a$, i - 1)
            a$ = LTRIM$(MID$(a$, i))
            IF LEFT$(b$, 2) = "#B" THEN
                mv = black
            ELSEIF LEFT$(b$, 2) = "#W" THEN
                mv = white
            ELSEIF LEFT$(b$, 1) = "#" THEN
                quit = TRUE
            ELSE
                i = Eval(b$)
                IF i < 1 OR i > maxmove THEN
                    IF mv > 0 THEN
                        DoMove "*" + STR$(mv) + " " + b$'assume it is a coord
                        mv = mv + 1
                    ELSEIF mv = black THEN
                        DoSetup "SETUP B " + b$
                    ELSEIF mv = white THEN
                        DoSetup "SETUP W " + b$
                    END IF
                ELSE
                    mv = i
                END IF
            END IF
        LOOP UNTIL quit = TRUE OR a$ = ""
    LOOP UNTIL quit = TRUE
    CLOSE #4
    IF c% < 1 OR c% > bdsize% THEN
        c% = 1
    END IF
    IF r% < 1 OR r% > bdsize% THEN
        r% = bdsize%
    END IF
END SUB

SUB GetFileLine (ch, a$)
    a$ = ""
    DO
        IF EOF(ch) THEN
            EXIT DO
        ELSE
            k$ = INPUT$(1, #ch)
        END IF
        IF ASC(k$) < 32 OR ASC(k$) > 127 THEN
            IF k$ = CHR$(10) THEN
                EXIT DO
            ELSEIF k$ = CHR$(9) THEN 'tab
                k$ = " "
            ELSE
                k$ = ""
            END IF
        END IF
        a$ = a$ + k$
    LOOP
END SUB

DEFSNG A-Z
FUNCTION GetLine$ (term$)
    a$ = ""
    LOCATE 23, 1
    PRINT "(Highest="; LTRIM$(STR$(Highest%)); ")    ";
    LOCATE 24, 1
    PRINT MID$(column$, c%, 1); LTRIM$(STR$(r%)); " ";
    PRINT "("; LTRIM$(STR$(b%(c%, r%))); ")   ";
    LOCATE 24, 12
    PRINT "       ";
    LOCATE 24, 12
    DO
        DO
            k$ = INKEY$
        LOOP UNTIL k$ <> ""
        IF k$ = CHR$(8) OR k$ = "/" THEN
            IF LEN(a$) THEN a$ = LEFT$(a$, LEN(a$) - 1)
            LOCATE 24, 12
            PRINT "       ";
            LOCATE 24, 12
            PRINT a$;
            k$ = "0"
        ELSE
            a$ = a$ + k$
            IF INSTR(BufferChar$, k$) THEN PRINT k$;
        END IF
    LOOP WHILE INSTR(BufferChar$, k$)
    PRINT "                                              ";
    term$ = k$
    'vvvvvvvvvvvvvvvvvvvvvvvvvvv For keycode checking
    develop = 0 'Should be 0 normally
    IF develop = 1 THEN
        CLS
        PRINT LEN(a$),
        FOR i = 1 TO LEN(a$)
            PRINT i; "="; ASC(MID$(a$, i, 1)),
        NEXT i
        INPUT b$
    END IF
    '^^^^^^^^^^^^^^^^^^^^^^^^^^ End keycode checking
    GetLine$ = a$
END FUNCTION

DEFINT A-Z
FUNCTION Hc (coord)
    SELECT CASE bdsize%
        CASE 7
            Hc = (coord = 4)
        CASE 9
            Hc = (coord = 5)
        CASE 11
            Hc = (coord = 6)
        CASE 13 TO 18
            Hc = (coord = 4) OR (coord = (bdsize% - 3))
        CASE 19
            Hc = ((coord = 4) OR (coord = 10) OR (coord = 16))
        CASE ELSE
            Hc = 0
        'END CASE
    END SELECT
END FUNCTION

SUB Import
    CLS
    PRINT "This option permits the importing of the mainstream of an ISHI"
    PRINT "format game record. Where a stone or marking is already on the"
    PRINT "board, the new stone is NOT used. All variations are ignored."
    PRINT
    PRINT "Enter a file from the current path, or # to change the"
    PRINT "path. Enter drives and directories, . & .. work. Return by"
    PRINT "itself quits import."
    path$ = "C:\TEMP\"
    q$ = CHR$(34)
    DO
        PRINT path$
        SHELL ("dir /w /ad " + path$ + ". | find " + q$ + "[" + q$)
        SHELL ("dir /w " + path$ + "*.go | find " + q$ + ".GO" + q$)
        INPUT " Enter filename (No '.GO') (null=exit, #=path) > ", f$
        IF f$ = "#" THEN
            INPUT " Modify Path (null=OK) > ", p$
            IF MID$(p$, 2, 1) = ":" THEN
                path$ = p$
            ELSEIF LEFT$(p$, 1) = "\" THEN
                path$ = LEFT$(path$, 2) + p$
            ELSEIF LEFT$(p$, 2) = ".." THEN
                i = 0
                j = 0
                k = INSTR(path$, "\")
                DO
                    i = j
                    j = k
                    k = INSTR(j + 1, path$, "\")
                LOOP UNTIL k = 0
                IF i = 0 THEN
                    i = 3
                END IF
                path$ = LEFT$(path$, i) + MID$(p$, 4)
            ELSEIF LEFT$(p$, 1) = "." THEN
                path$ = path$ + MID$(p$, 3)
            ELSE
                path$ = path$ + p$
            END IF
            path$ = UCASE$(path$)
            IF RIGHT$(path$, 1) <> "\" THEN
                path$ = path$ + "\"
            END IF
        END IF
    LOOP UNTIL f$ <> "#"
    IF f$ = "" THEN
        EXIT SUB
    END IF
    f$ = path$ + UCASE$(f$) + ".GO"
    PRINT "Source file = "; f$
    CLOSE #3
    OPEN f$ FOR INPUT AS #3
    PRINT "Notes on duplicate moves copied to " + temp$ + "\ENTERGO.TXT"
    CLOSE #4
    OPEN temp$ + "\ENTERGO.TXT" FOR OUTPUT AS #4
    PRINT #4, "Notes on "; f$
    IF bdsize% <> 19 THEN
        var = -1 'Prevent missing BOARDSIZE command unless on 19*19
    ELSE
        var = 0
    END IF
    setup = TRUE
    quit = False
    DO WHILE (EOF(3) = False) AND (quit = False)
        GetFileLine 3, a$
        a$ = UCASE$(LTRIM$(a$))
        'PRINT a$ 'debug
        IF LEFT$(a$, 3) = "VAR" THEN
            var = var + 1
        ELSEIF LEFT$(a$, 6) = "ENDVAR" THEN
            var = var - 1
        ELSEIF LEFT$(a$, 9) = "BOARDSIZE" THEN
            IF VAL(MID$(a$, 11)) <> bdsize% THEN
                INPUT "Boardsize mismatch."; a$
                PRINT #4, "Boardsize mismatch."
                quit = TRUE
            END IF
            var = 0
        ELSEIF var = 0 THEN
            IF LEFT$(a$, 2) = "B " THEN
                DoMove a$
                setup = False
            ELSEIF LEFT$(a$, 2) = "W " THEN
                DoMove a$
                setup = False
            ELSEIF LEFT$(a$, 5) = "SETUP" THEN
                IF setup = TRUE THEN
                    DoSetup a$
                END IF
            END IF
        END IF
    LOOP
    IF var <> 0 THEN
        PRINT #4, "Either BOARDSIZE mismatch or VAR mismatch."
    END IF
    CLOSE #3
    CLOSE #4
    INPUT "Done ", a$
END SUB

DEFSNG A-Z
SUB Instructions
    CLS
    PRINT "      ";
    Bold "***************** " + Version$ + " " + ext$ + " ******************"
    PRINT
    Bold "Cursors"
    PRINT " = Nop, Move (& wrap) as arrow. ";
    Bold "CR"
    PRINT " = Nop, Move (& wrap) right."
    Bold "Home"
    PRINT " = Move to top left of board.      ";
    Bold "End"
    PRINT " = Move to end of line."
    Bold "B"
    PRINT " = Black setup stone.                 ";
    Bold "W"
    PRINT " = White setup stone."
    Bold "Space"
    PRINT " = Empty point.                   ";
    Bold "Del"
    PRINT " = Delete point despite 'Preserve'."
    Bold "*a"
    PRINT " = label A (any letter a-z after * is possible) or number 1..99."
    PRINT "    (";
    Bold "*@"
    PRINT " is triangle, ";
    Bold "*["
    PRINT " is square.) Displayed in < > brackets."
    Bold "&a"
    PRINT " as '*a' but Black marking. ";
    Bold "(a"
    PRINT " as '*a' but White marking. "
    Bold ">"
    PRINT " = Push row right from (incl) cursor. ";
    Bold "<"
    PRINT " = Suck row left into cursor."
    Bold "v"
    PRINT " = Push rows down incl cursor.        ";
    Bold "^"
    PRINT " = Suck rows up into cursor."
    Bold "Number (1 to" + STR$(maxmove) + ")"
    PRINT " = Relevant stone. (Backspace works.)"
    PRINT "    ";
    Bold "/"
    PRINT " acts like backspace. (Duplicate/illegal moves BEEP & need reentry.)"
    PRINT "    (Program 'burps' at start of new line.)"
    Bold "+"
    PRINT " = Entry action becomes 'move right one point'."
    Bold "="
    PRINT " = Entry action becomes 'stay at same point'."
    Bold "!"
    PRINT " = Display stones < 'nnn' as 'setup stones'. Set entry offset."
    PRINT "    Define max stone to display. Preserve stones."
    Bold "#"
    PRINT " = Create HTML gif dump file.         ";
    Bold "~"
    PRINT " = Corner for HTML/ASCII outputs."
    Bold "@"
    PRINT " = Create ISHI format file.           ";
    Bold ":"
    PRINT " = Create ASCII picture file."
    Bold "Insert"
    PRINT " = Read an ISHI format file.     ";
    Bold "shift Tab"
    PRINT " = Enter as coordinates."
    Bold "Q"
    PRINT " or ";
    Bold "alt F4"
    PRINT " = Quit program / Restart program."
    Bold "?"
    PRINT " = Show these instructions again."
END SUB

DEFINT A-Z
SUB Missing
PRINT
PRINT "'###' = a number stone (eg move '123');"
PRINT "'A##' = a coordinate (eg 'k10');"
PRINT "'z' = pass;"
PRINT "'y' = pass with added comments;"
PRINT "'' (null) = Add a comment saying move is missing;"
PRINT "'x' = exit (Write file to disk and return to board)."
PRINT "'?' = print this help list again with a revised missing list."
PRINT
PRINT "Missing moves:"
fm = 0 'First missing move in a range
lm = 0 'Last missing move in a range
FOR m = 1 TO maxmove
    IF (move%(m, 1) <= 0) AND (m <= Highest%) THEN
        'Move missing
        IF fm = 0 THEN
            fm = m
        ELSE
            lm = m
        END IF
    ELSE
        'Move either present or after end of game
        IF fm = 0 THEN
            'Don't print anything
        ELSEIF lm = 0 THEN
            'It is a single missing move
            PRINT fm; "  ";
        ELSE
            PRINT fm; "-"; lm; "  ";
        END IF
        IF POS(0) > 70 THEN PRINT
        fm = 0
        lm = 0
    END IF
NEXT m
PRINT
PRINT "Highest move ="; Highest%
END SUB

SUB move1colour
    PRINT "Move 1 was Black or White (B/W) ["; MID$(colour$, 2, 1); "] > ";
    INPUT a$
    a$ = UCASE$(a$)
    IF a$ = "B" THEN
        colour$ = bk$ + wt$
    ELSEIF a$ = "W" THEN
        colour$ = wt$ + bk$
    END IF
END SUB

FUNCTION NormalCorners$ (aa$, xl, xr, yl, yr)
    a$ = UCASE$(aa$)
    'a1e5 is a problem, 1e5 is interpreted as the number 100000
    'change all E to Z
    i = INSTR(a$, "E")
    DO WHILE i
        MID$(a$, i, 1) = "Z"
        i = INSTR(a$, "E")
    LOOP
    'a1d5 is a problem, 1d5 is interpreted as the number 100000
    'change all D to Y
    i = INSTR(a$, "D")
    DO WHILE i
        MID$(a$, i, 1) = "Y"
        i = INSTR(a$, "D")
    LOOP
    xlc$ = MID$(a$, 1, 1)
    xl = INSTR(kolumn$, xlc$)
    yl = VAL(MID$(a$, 2))
    xrc$ = MID$(a$, 1 + LEN(STR$(yl)), 1)
    xr = INSTR(kolumn$, xrc$)
    yr = VAL(MID$(a$, 2 + LEN(STR$(yl))))
    IF xl > xr THEN
        xt = xr
        xr = xl
        xl = xt
    END IF
    IF yl > yr THEN
        yt = yr
        yr = yl
        yl = yt
    END IF
    IF xl >= 1 AND xr <= bdsize% AND xl <= xr THEN
        IF yl >= 1 AND yr <= bdsize% AND yl <= yr THEN
            g$ = UCASE$(MID$(column$, xl, 1))
            g$ = g$ + LTRIM$(STR$(yl))
            g$ = g$ + UCASE$(MID$(column$, xr, 1))
            g$ = g$ + LTRIM$(STR$(yr))
        END IF
    END IF
    NormalCorners$ = g$
END FUNCTION

SUB Options
    CLS
    PRINT "Stones up to"; showsetup%; "are displayed as 'setup' stones"
    PRINT "("; bk$; " or "; wt$; "). Enter '0' to display all stones fully numbered."
    PRINT "Suppress stone numbers up to ["; showsetup%; "] > ";
    INPUT a$
    IF a$ <> "" THEN
        showsetup% = ABS(VAL(a$))
    END IF
    PRINT
    move1colour
    PRINT
    PRINT "When entering move numbers, what offset is required?"
    PRINT "(Often this will be 100 to permit typing '23' for move '123.)"
    PRINT "(To enter moves that omit this scheme, enter them negative :"
    PRINT "    So '23' is '123' and '-23' is really '23'.)"
    PRINT "Offset to be ["; offset%; "] > ";
    INPUT a$
    IF a$ <> "" THEN
        offset% = ABS(VAL(a$))
    END IF
    PRINT
    PRINT "When displaying move numbers, what offset is required?"
    PRINT "(Often this will be the same as the entry offset above to permit"
    PRINT "variation diagrams to be displayed."
    PRINT "Display offset to be ["; displayoffset%; "] > ";
    INPUT a$
    IF a$ <> "" THEN
        displayoffset% = ABS(VAL(a$))
    END IF
    PRINT
    PRINT "Stones above"; maxshow%; "are displayed as 'empty' points."
    PRINT "(: to distinguish them from .)."
    PRINT "Suppress stones numbered above ["; maxshow%; "] > ";
    INPUT a$
    IF a$ <> "" THEN
        maxshow% = ABS(VAL(a$))
    END IF
    PRINT
    PRINT "Points on the board can be overwritten or protected if non-empty."
    PRINT "Set 'PRESERVE' to (0/1) ["; preserve%; "] > ";
    INPUT a$
    IF a$ <> "" THEN
        preserve% = ABS(NOT (VAL(a$) = 0))
    END IF
    PRINT
    PRINT "It is possible to automatically remove stones above a certain number"
    PRINT "from the board. Useful if entering variations."
    i = maxmove + 1
    PRINT "Remove stones including and above ["; i; "] > ";
    INPUT a$
    IF a$ <> "" THEN
        i = ABS(VAL(a$))
    END IF
    IF i < Highest% THEN
        FOR y = 1 TO bdsize%
            FOR x = 1 TO bdsize%
                mn = b%(x, y)
                IF mn >= i THEN
                    b%(x, y) = empty
                    rw%(mn) = 0
                END IF
            NEXT x
        NEXT y
    END IF
    PRINT
    PRINT "It is possible to automatically remove markup letters"
    PRINT "from the board. Useful if entering variations."
    b$ = "N"
    PRINT "Remove markup letters (Y/N) [N] > ";
    INPUT a$
    IF a$ <> "" THEN
        b$ = UCASE$(a$)
    END IF
    IF b$ = "Y" THEN
        FOR y = 1 TO bdsize%
            FOR x = 1 TO bdsize%
                mn = b%(x, y)
                IF mn < (label + 102) THEN
                    b%(x, y) = empty
                END IF
            NEXT x
        NEXT y
    END IF
END SUB

SUB ShiftDown
    FOR rr = 1 TO r% - 1 'Won't do anything if r%=1
        FOR cc = 1 TO bdsize%
            'Unlist this cell
            mn = b%(cc, rr)
            IF mn > 0 THEN 'If a move is there, unlist it
                rw%(mn) = 0
            END IF
            'Copy the row above into this cell
            b%(cc, rr) = b%(cc, rr + 1)
            mn = b%(cc, rr)
            IF mn > 0 THEN 'If a numbered move, list it
                rw%(mn) = rr
            END IF
            'Empty the cell above (Link already corrected)
            b%(cc, rr + 1) = empty
        NEXT cc
    NEXT rr
    ShowAll
END SUB

SUB ShiftLeft
    mn = b%(c%, r%) 'Get the current move
    IF mn > 0 THEN 'If a move is there, delete it
        rw%(mn) = 0
        b%(c%, r%) = empty
    END IF
    FOR cc = c% TO (bdsize% - 1)'Won't do any loops if c%=bdsize%
        b%(cc, r%) = b%(cc + 1, r%) 'Move it left one place
    NEXT cc
    b%(bdsize%, r%) = empty
END SUB

DEFSNG A-Z
SUB ShiftRight
    mn = b%(bdsize%, r%) 'Get the rightmost move
    IF mn > 0 THEN 'If a move is there, delete it
        rw%(mn) = 0
        b%(bdsize%, r%) = empty
    END IF
    FOR cc = (bdsize% - 1) TO c% STEP -1'Won't do any loops if c%=bdsize%
        b%(cc + 1, r%) = b%(cc, r%)'Move it right one place
    NEXT cc
    mn = b%(c%, r%)
    IF mn > 0 THEN 'If a move is there, empty it
        rw%(mn) = 0
    END IF
    b%(c%, r%) = empty
END SUB

DEFINT A-Z
SUB ShiftUp
    FOR rr = r% TO 2 STEP -1 'Won't do anything if r%=1
        FOR cc = 1 TO bdsize%
            'Unlist this cell
            mn = b%(cc, rr)
            IF mn > 0 THEN 'If a move is there, unlist it
                rw%(mn) = 0
            END IF
            'Copy the row below into this cell
            b%(cc, rr) = b%(cc, rr - 1)
            mn = b%(cc, rr)
            IF mn > 0 THEN 'If a numbered move, list it
                rw%(mn) = rr
            END IF
            'Empty the cell below (Link already corrected)
            b%(cc, rr - 1) = empty
        NEXT cc
    NEXT rr
    ShowAll
END SUB

DEFSNG A-Z
SUB Show (y)
LOCATE 21 - y, 1
FOR x = 1 TO bdsize%
    a$ = " " + Disp$(INT(x), INT(y))
    PRINT a$;
NEXT x
PRINT y
END SUB

SUB ShowAll
    CLS
    FOR x = 1 TO bdsize%
        PRINT "   "; MID$(column$, x, 1);
    NEXT x
    PRINT
    FOR y = bdsize% TO 1 STEP -1
        Show y
    NEXT y
END SUB

SUB ToFile
    CLS
    f$ = "ENTERGO"
    PRINT "Filename [no .GO] ("; f$; ")";
    INPUT "?", a$
    IF a$ <> "" THEN f$ = a$
    f$ = UCASE$(temp$ + "\" + f$ + ".go")
   
    PRINT "Writing to file " + f$
    PRINT
    move1colour
    IF colour$ = bk$ + wt$ THEN
        colr$ = "BW"
    ELSE
        colr$ = "WB"
    END IF
    PRINT
    OPEN f$ FOR OUTPUT AS #1
    PRINT #1, "EVENT"
    FOR m = 1 TO maxmove
        move%(m, 1) = 0
        move%(m, 2) = 0
    NEXT m
    FOR y = 1 TO bdsize%
        FOR x = 1 TO bdsize%
            mn = b%(x, y)
            c$ = " " + MID$(column$, x, 1) + LTRIM$(STR$(y))
            IF mn = black THEN
                PRINT #1, "SETUP B" + c$
            ELSEIF mn = white THEN
                PRINT #1, "SETUP W" + c$
            ELSEIF mn > 0 THEN
                move%(mn, 1) = x
                move%(mn, 2) = y
            END IF
        NEXT x
    NEXT y
    Missing
    FOR m = 1 TO maxmove
        IF move%(m, 1) > 0 THEN
            c$ = " " + MID$(column$, move%(m, 1), 1) + LTRIM$(STR$(move%(m, 2)))
            PRINT #1, LEFT$(colr$, 1); m; c$
        ELSE
            DO
                IF m > Highest% THEN PRINT "Above highest move."
                PRINT "Where is move"; m; "? (###, A##, z/y(pass), Null(omit), x(exit)), ?(help) ";
                LINE INPUT a$
                IF a$ = "x" THEN
                    EXIT FOR
                ELSEIF a$ = "" THEN
                    PRINT #1, "COM"
                    PRINT #1, "Move missing:"; m
                    PRINT #1, "ENDCOM"
                ELSEIF a$ = "z" OR a$ = "y" THEN
                    PRINT #1, LEFT$(colr$, 1); m; " pass"
                    PRINT #1, "COM"
                    PRINT #1, "Pass"
                    IF a$ = "y" THEN
                        LINE INPUT ">", a$
                        PRINT #1, a$
                    END IF
                    PRINT #1, "ENDCOM"
                ELSEIF a$ = "?" THEN
                    Missing
                ELSE
                    a = INSTR(column$, LEFT$(a$, 1))
                    IF a = 0 THEN
                        a = Eval(a$)
                        move%(m, 1) = move%(a, 1)
                        move%(m, 2) = move%(a, 2)
                    ELSE
                        b = Eval(MID$(a$, 2))
                        move%(m, 1) = a
                        move%(m, 2) = b
                    END IF
                    c$ = " " + MID$(column$, move%(m, 1), 1) + LTRIM$(STR$(move%(m, 2)))
                    PRINT #1, LEFT$(colr$, 1); m; c$
                END IF
            LOOP WHILE a$ = "?"
        END IF
        colr$ = RIGHT$(colr$, 1) + LEFT$(colr$, 1)
    NEXT m
    CLOSE #1
    PRINT "File is "; f$; "."
    PRINT "(Press a key.)"
    a$ = INPUT$(1)
END SUB

DEFINT A-Z
SUB ToHtml (Html)
'Html is TRUE to output an HTML picture file and FALSE for an ASCII file
CLS
SHELL "dir /w " + temp$ + "\h_*.txt"
PRINT
minlabel = ASC("@")
maxlabel = ASC("[")
maxnum = maxmove
grid$ = NormalCorners$(corner$(1) + corner$(2), xl, xr, yl, yr)
IF Html THEN
    ShowCoord$ = "N"
ELSE
    ShowCoord$ = "Y"
END IF
DO
    PRINT "Page number ("; Pg$; ")";
    INPUT "?", a$
    IF a$ <> "" THEN Pg$ = RIGHT$(STR$(1000 + VAL(a$)), 2)

    PRINT "Type ("; Type$; ")";
    INPUT "?", a$
    IF a$ <> "" THEN Type$ = a$

    PRINT "Diagram Number ("; DiaNum$; ")";
    INPUT "?", a$
    IF a$ <> "" THEN DiaNum$ = a$

    ff$ = LEFT$("h_" + Pg$ + LEFT$(Type$, 1) + DiaNum$, 8) + ".txt"
    id$ = LCASE$(LEFT$(Type$, 3) + DiaNum$)
   
    PRINT
    PRINT "Writing to file " + LCASE$(temp$ + "\" + ff$)

    PRINT
    PRINT "(All move numbers are raw 'pre-reduction' numbers.)"
    move1colour
    a$ = MID$(colour$, 2, 1)
    IF a$ = "W" THEN
        colr$ = "bwcx"
    ELSE
        colr$ = "wbxc"
    END IF
    PRINT " "; a$

    PRINT "Blank numbers upto & including ("; Blanknum; ")";
    INPUT a$
    IF a$ <> "" THEN
        IF (VAL(a$) > 0) OR (a$ = "0") THEN Blanknum = VAL(a$)
    END IF
    PRINT Blanknum

    PRINT "Reduce shown numbers by ("; Reduce; ")";
    INPUT a$
    IF a$ <> "" THEN
        IF (VAL(a$) > 0) OR (a$ = "0") THEN Reduce = VAL(a$)
    END IF
    IF Reduce > Blanknum THEN
        Reduce = Blanknum
    END IF
    PRINT Reduce

    PRINT "Output stones up to number ("; maxnum; ")";
    INPUT a$
    IF a$ <> "" THEN
        IF (VAL(a$) > 0) OR (a$ = "0") THEN maxnum = VAL(a$)
    END IF
    PRINT maxnum

    PRINT "Display Coordinates [Y/N] ("; ShowCoord$; ")";
    INPUT "?", a$
    IF a$ <> "" THEN
        a$ = UCASE$(LEFT$(a$, 1))
        IF INSTR("YN", a$) THEN ShowCoord$ = a$
    END IF

    PRINT "Grid: Output partial grid [lnnlnn] ("; grid$; ")";
    INPUT a$
    IF LEN(a$) >= 4 THEN
        grid$ = NormalCorners$(a$ + grid$, xl, xr, yl, yr)
    END IF
    PRINT grid$

    IF Html = False THEN
        PRINT "Ascii2 ("; Ascii2; ")";
        INPUT "?", a$
        IF a$ <> "" THEN Ascii2 = NOT (NOT (VAL(a$)))
    END IF

    DO
        INPUT "OK (y/n/q)"; a$
        a$ = UCASE$(a$)
    LOOP UNTIL INSTR("YNQ", a$) AND a$ <> ""
LOOP UNTIL INSTR("YQ", a$)

IF UCASE$(a$) = "Y" THEN
    qt$ = CHR$(34)
    OPEN temp$ + "\" + ff$ FOR OUTPUT AS #1
    IF Html THEN
        PRINT #1, "<table> <tr> <td>"
        PRINT #1, "<td><img src=" + qt$ + "___" + ext$ + qt$ + ">"
        PRINT #1, "<td>"
        PRINT #1, "<a name=" + qt$ + id$ + qt$ + " href=" + qt$ + "#" + id$ + qt$ + "> " + Type$ + " " + DiaNum$ + "</a> <br>"
        PRINT #1, "<small> <i> BGJ had Fig 0a and 0b as one diagram, Fig 0. </i> </small> ";
    ELSE
        PRINT #1, Type$ + " " + DiaNum$
    END IF
    FOR y = yr TO yl STEP -1
        i$ = ""
        t$ = "" 'Used to build up the text for the ascii file version
        t2$ = "" 'This is for the right half of the diagram
        o$ = ""
        IF Html THEN
            PRINT #1, "<br>"
            PRINT #1, "<!-- row"; y; " --><img"
        END IF
        IF ShowCoord$ = "Y" THEN
            IF y < 10 THEN
                IF Html THEN
                    l$ = "g~" + LTRIM$(STR$(y))
                    PRINT #1, "src=" + qt$ + l$ + ext$ + qt$ + "><img ";
                ELSE
                    i$ = i$ + STR$(y)
                END IF
            ELSE
                IF Html THEN
                    l$ = "g" + LTRIM$(STR$(INT(y / 10))) + "_"
                    r$ = "h_" + LTRIM$(STR$(y MOD 10))
                    PRINT #1, "src=" + qt$ + l$ + ext$ + qt$ + "><img ";
                    PRINT #1, "src=" + qt$ + r$ + ext$ + qt$ + "><img ";
                ELSE
                    i$ = i$ + LTRIM$(STR$(y))
                END IF
            END IF
            IF Html THEN
                PRINT #1, "src=" + qt$ + "___" + ext$ + qt$ + "><img"
            ELSE
                i$ = i$ + " "
            END IF
        END IF
        IF xl = 1 THEN i$ = i$ + "|"
        FOR x = xl TO xr
            mn = b%(x, y)
            mcolr = mn MOD 2
            IF mn <= 0 THEN
                'nop
            ELSEIF mn > maxnum THEN
                mn = 0
            ELSEIF mn <= Blanknum THEN
                IF MID$(colr$, ((1000 + mn) MOD 2) + 1, 1) = "b" THEN
                    mn = black
                ELSE
                    mn = white
                END IF
            ELSE
                mn = mn - Reduce
            END IF
            r$ = ""
            as2$ = " ."
            IF mn = black THEN
                l$ = "b__"
                as$ = " #"
                as2$ = " #"
            ELSEIF mn = white THEN
                l$ = "w__"
                as$ = " O"
                as2$ = " O"
            ELSEIF mn > (label + minlabel) AND mn < (label + maxlabel) THEN
                as$ = LCASE$(CHR$(mn - label))
                l$ = "g~" + as$
                as$ = " " + as$
            ELSEIF mn > (blabel + minlabel) AND mn < (blabel + maxlabel) THEN
                as$ = LCASE$(CHR$(mn - blabel))
                l$ = "b~" + as$
                as$ = "#" + as$
                as2$ = " #"
            ELSEIF mn > (wlabel + minlabel) AND mn < (wlabel + maxlabel) THEN
                as$ = LCASE$(CHR$(mn - wlabel))
                l$ = "w~" + as$
                as$ = "O" + as$
                as2$ = " O"
            ELSEIF mn = label + minlabel THEN
                l$ = "gtr"
                as$ = " @"
            ELSEIF mn = blabel + minlabel THEN
                l$ = "btr"
                as$ = "#@"
                as2$ = " #"
            ELSEIF mn = wlabel + minlabel THEN
                l$ = "wtr"
                as$ = "O@"
                as2$ = " O"
            ELSEIF mn = label + maxlabel THEN
                l$ = "gsq"
                as$ = " *"
            ELSEIF mn = blabel + maxlabel THEN
                l$ = "bsq"
                as$ = "#*"
                as2$ = " #"
            ELSEIF mn = wlabel + maxlabel THEN
                l$ = "wsq"
                as$ = "O*"
                as2$ = " O"
            ELSEIF (mn < label) AND (mn > (label - 10)) THEN
                mn = label - mn
                as$ = STR$(mn)
                l$ = "g~" + LTRIM$(as$)
            ELSEIF (mn <= (label - 10)) AND (mn >= label - 99) THEN
                mn = label - mn
                l$ = "g" + LTRIM$(STR$(INT(mn / 10))) + "_"
                r$ = "h_" + LTRIM$(STR$(mn MOD 10))
                as$ = LTRIM$(STR$(mn))
            ELSEIF mn >= 100 THEN
                l$ = MID$(colr$, mcolr + 1, 1) + MID$("0123456789abcdefghijklmnopqrstuvwxyz", 1 + INT(mn / 10), 1) + LTRIM$(STR$(mn MOD 10))
                as$ = "[]" 'Can't handle this situation"
                as2$ = "[]" 'Can't handle this situation"
            ELSEIF mn >= 10 THEN
                l$ = MID$(colr$, mcolr + 1, 1) + LTRIM$(STR$(INT(mn / 10))) + "_"
                r$ = MID$(colr$, mcolr + 3, 1) + "_" + LTRIM$(STR$(mn MOD 10))
                as$ = LTRIM$(STR$(mn))
                IF LEFT$(l$, 1) = "b" THEN
                    as2$ = " #"
                ELSE
                    as2$ = " O"
                END IF
            ELSEIF mn > 0 THEN
                l$ = MID$(colr$, mcolr + 1, 1) + "~" + LTRIM$(STR$(mn MOD 10))
                as$ = STR$(mn)
                IF LEFT$(l$, 1) = "b" THEN
                    as2$ = " #"
                ELSE
                    as2$ = " O"
                END IF
            ELSE
                as$ = " ."
            END IF
            IF as$ = " ." THEN
                IF y = bdsize% THEN
                    IF x = 1 THEN
                        g$ = "nw"
                    ELSEIF x = bdsize% THEN
                        g$ = "ne"
                    ELSE
                        g$ = "n_"
                    END IF
                ELSEIF y = 1 THEN
                    IF x = 1 THEN
                        g$ = "sw"
                    ELSEIF x = bdsize% THEN
                        g$ = "se"
                    ELSE
                        g$ = "s_"
                    END IF
                ELSE
                    IF x = 1 THEN
                        g$ = "w_"
                    ELSEIF x = bdsize% THEN
                        g$ = "e_"
                    ELSE
                        g$ = "md"
                        IF Hc(y) AND Hc(x) THEN
                            g$ = "hc"
                            IF as$ = " ." THEN
                                as$ = " ,"
                            END IF
                            as2$ = " ,"
                        END IF
                    END IF
                END IF
                l$ = "g" + g$
            END IF
            IF Html THEN
                PRINT #1, "src=" + qt$ + l$ + ext$ + qt$ + ">";
            ELSE
                t$ = t$ + as$
                t2$ = t2$ + as2$
            END IF
            IF r$ <> "" THEN
                IF Html THEN PRINT #1, "<img src=" + qt$ + r$ + ext$ + qt$ + ">";
            END IF
            IF x = xr THEN
                IF NOT Html THEN
                    IF xr = bdsize% THEN
                        o$ = " |"
                    END IF
                END IF
            ELSEIF (x MOD 2) = 1 THEN
                IF Html THEN PRINT #1, "<img ";
            ELSE
                IF Html THEN PRINT #1, "<img"
            END IF
        NEXT x
        IF NOT Html THEN
            IF LEN(o$) THEN
                oo$ = "-" + SPACE$(LEN(o$) - 1)
            ELSE
                oo$ = ""
            END IF
            IF y = bdsize% THEN
                PRINT #1, SPACE$(LEN(i$)); STRING$(LEN(t$), "-"); oo$;
                IF Ascii2 THEN
                    PRINT #1, "    "; SPACE$(LEN(i$)); STRING$(LEN(t2$), "-"); oo$
                ELSE
                    PRINT #1,
                END IF
            END IF
            PRINT #1, i$; t$; o$;
            IF Ascii2 THEN
                PRINT #1, "    "; i$; t2$; o$
            ELSE
                PRINT #1,
            END IF
            IF y = 1 THEN
                PRINT #1, SPACE$(LEN(i$)); STRING$(LEN(t$), "-"); oo$;
                IF Ascii2 THEN
                    PRINT #1, "    "; SPACE$(LEN(i$)); STRING$(LEN(t2$), "-"); oo$
                ELSE
                    PRINT #1,
                END IF
            END IF
        END IF
    NEXT y
    IF ShowCoord$ = "Y" THEN
        t$ = ""
        IF Html THEN
            PRINT #1, "<br>"
            PRINT #1, "<img src=" + qt$ + "___" + ext$ + qt$ + " height=" + qt$ + "10" + qt$ + "><br>";
            PRINT #1, "<img src=" + qt$ + "___" + ext$ + qt$ + ">";
            PRINT #1, "<img src=" + qt$ + "___" + ext$ + qt$ + ">";
            PRINT #1, "<img src=" + qt$ + "___" + ext$ + qt$ + "><img";
        ELSE
            t$ = t$ + SPACE$(LEN(i$))
        END IF
        FOR x = xl TO xr
            as$ = MID$(column$, x, 1)
            l$ = "g~" + as$
            IF Html THEN
                PRINT #1, "src=" + qt$ + l$ + ext$ + qt$ + ">";
                IF x = xr THEN
                    'nop
                ELSEIF (x MOD 2) = 1 THEN
                    PRINT #1, "<img ";
                ELSE
                    PRINT #1, "<img"
                END IF
            ELSE
                t$ = t$ + " " + as$
            END IF
        NEXT x
        IF NOT Html THEN
            t$ = t$ + SPACE$(LEN(o$))
            PRINT #1, t$;
            IF Ascii2 THEN
                PRINT #1, "    "; t$
            ELSE
                PRINT #1,
            END IF
        END IF
    END IF
    IF Html THEN
        PRINT #1, "<!-- " + Type$ + " " + DiaNum$ + " -->"
        PRINT #1, "</table>"
    END IF
    PRINT #1,
    CLOSE #1
END IF
END SUB

